#ifndef _SSSLIB_CPP_H
#define _SSSLIB_CPP_H

#include <ssslib.h>
#include <string.h>

class SSSException {
 public:
  char buf[MAXERRLENGTH];
};  

class SSSParseException : public SSSException {
 public:
  SSSParseException(char *msgbuf){
    strncpy(buf,msgbuf,MAXERRLENGTH);
  }
};

class SSSInitException : public SSSException {
 public:
  SSSInitException(char *msgbuf){
    strncpy(buf,msgbuf,MAXERRLENGTH);
  }
};

class SSSProtocolException : public SSSException {
 public:
  SSSProtocolException(char *msgbuf){
    strncpy(buf,msgbuf,MAXERRLENGTH);
  }
};

class SSSConnectException : public SSSException {
 public:
  SSSConnectException(char *msgbuf){
    strncpy(buf,msgbuf,MAXERRLENGTH);
  }
};

class SSSCommunicationException : public SSSException {
 public:
  SSSCommunicationException(char *msgbuf){
    strncpy(buf,msgbuf,MAXERRLENGTH);
  }
};

class SSSInternalException : public SSSException {
 public:
  SSSInternalException(char *msgbuf){
    strncpy(buf,msgbuf,MAXERRLENGTH);
  }
};

class SSS_Config_Dictionary {
 private:
  SSS_ConfigDict dict;
 public:
  SSS_Config_Dictionary(SSS_ConfigDict newdict){
    dict = newdict;
  }
  ~SSS_Config_Dictionary(void){
    SSS_FreeConfigDict(dict);
  }
  char *GetValue(char *key){
    return SSS_GetFromConfigDict(dict,key);
  }
};

class comm_lib {
 private:
  SSS sss;
  SSS_Connection SDLookup(char *service);
  void throw_exception(int errnum);
 public:
  comm_lib();
  comm_lib(int debug);
  comm_lib(char *conffile);
  comm_lib(char *conffile,int debug);
  ~comm_lib();
  int SDRegister(char *service,char *host,int port,char *protocol,char *schema_version,char *tier);
  int SDRemove(char *service,char *host,int port,char *protocol);
  char *ServerInit(int socket);
  char *ClientInit(char *service);
  int ClientClose(char *handle);
  int ServerClose(char *handle);
  int SendMessage(char *handle,char *message);
  char *RecvMessage(char *handle);
  SSS_Config_Dictionary *GetConfig(void);
};  

#endif
